/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#ifdef TRAP_LOG

#include <stdio.h>
#include <string.h>

static char *file[5] = {0L, 0L, 0L, 0L, 0L};
static long lines[5] = {-1L, -1L, -1L, -1L, -1L};

/* logfunc(__FILE__, __LINE__); */

void logfunc(char *f, long l)
{
if (lines[2] != l || file[2] == 0L || strcmp(file[2], f))
	{
	int i;
	
	for (i = 0; i < 4; i++)	
		{
		file[i] = file[i + 1];
		lines[i] = lines[i + 1];
		}
		
	file[4] = f;
	lines[4] = l;
	}
}

void dump_locations(char *buffer)
{
int i;

for (i = 0; i < 5; i++)
	if (file[i] != 0L)
		{
		char *s;
		
		s = strrchr(file[i], '\\');
		if (!s) s = file[i]; else s++;
		sprintf(buffer + strlen(buffer), "  %s %ld\n", s, lines[i]);
		}
}

#endif
