/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

/* ---------------------------------
   | Bitblit from screen/to screen |
   --------------------------------- */
void blt_copy(void *from, int xf, int yf, void *to, int xt, int yt, int w, int h, int cpy_mode)
{
MFDB src, des;
int xy[8];

DEBUG();
memset(&src, 0, sizeof(MFDB));
memset(&des, 0, sizeof(MFDB));

src.fd_addr			= from;
if (from)
	{
	src.fd_w 				= xf + w;
	src.fd_h				= yf + h;
	src.fd_wdwidth 	= (xf + w + 15) >> 4;
	src.fd_stand		= 0;
	src.fd_nplanes  = planes;
	src.fd_r1 = src.fd_r2 = src.fd_r3 = 0;
	}

des.fd_addr			= to;
if (to)
	{
	des.fd_w 				= xt + w;
	des.fd_h				= yt + h;
	des.fd_wdwidth 	= (xt + w + 15) >> 4;
	des.fd_stand		= 0;
	des.fd_nplanes  = planes;
	des.fd_r1 = des.fd_r2 = des.fd_r3 = 0;
	}
		
xy[0] = xf;
xy[1] = yf;
xy[2] = xf + w - 1;
xy[3] = yf + h - 1;
xy[4] = xt;
xy[5] = yt;
xy[6] = xt + w - 1;
xy[7] = yt + h - 1;

vro_cpyfm(vdi_handle, cpy_mode, xy, &src, &des);
}

