/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

/* ------------------------------
   | Set color values for files |
   ------------------------------ */
int colorFiles(int filecnt, struct ftp_lsblk *files,
							 int comparecnt, struct ftp_lsblk *cfiles)
{
int i, j, r = FALSE, c;
char buf[65];

DEBUG();
for (i = 0; i < filecnt; i++)
	{
	c = files[i].color;
	
	if (!files[i].dir)
		{
		strcpy(buf, files[i].name);
		
		switch(act_conndef.case_mode)
			{
			case 1:
				strupr(buf);
				break;
				
			case 2:
				strlwr(buf);
				break;
			}
			
		for (j = 0; j < comparecnt; j++)
			if (!strcmp(buf, cfiles[j].name))
				break;
				
		if (j == comparecnt)
			{
			c = ftp_opts.nonexist;
			files[i].newer = TRUE;
			files[i].exists = FALSE;
			}
		else
			{
			int c1[6], c2[6], r;
			
			c1[0] = files[i].year;
			c1[1] = files[i].month;
			c1[2] = files[i].day;
			c1[3] = files[i].hour;
			c1[4] = files[i].min;
			c1[5] = files[i].sec;
			
			c2[0] = cfiles[j].year;
			c2[1] = cfiles[j].month;
			c2[2] = cfiles[j].day;
			c2[3] = cfiles[j].hour;
			c2[4] = cfiles[j].min;
			c2[5] = cfiles[j].sec;
			
			r = memcmp(c1, c2, sizeof(c1));
			if (r > 0)
				{
				c = ftp_opts.newer;
				files[i].newer = TRUE;
				files[i].exists = TRUE;
				}
			else
				if (r < 0)
					{
					c = ftp_opts.older;
					files[i].newer = FALSE;
					files[i].exists = TRUE;
					}
				else
					{
					c = ftp_opts.same;
					files[i].newer = FALSE;
					files[i].exists = TRUE;
					}
			}
		}
	else
		{
		c = ftp_opts.nonexist;
		files[i].newer = TRUE;
		files[i].exists = FALSE;
		}
		
	if (c != files[i].color)
		{
		files[i].color = c;
		r = TRUE;
		}
	}
	
return r;
}
