/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

static char path[MAXDRIVE + MAXPATH];
static int path_flg = FALSE;
char sharedpath[256];

long cdecl __sock_call__(long fnc, ...);

static int bootdrv;
static char slbpath[256*3];

/* ------------------
   | Get boot drive |
   ------------------ */
void get_bootdrive(void)
{
long old_stk;

DEBUG();
if (!Super((void *)1L))
	old_stk = Super(0L);
else	
	old_stk = 0;

bootdrv = *(int *)0x446;
	
if (old_stk)
	Super((void *)old_stk);	
}

/* -------------------------------
   | Read installation directory |
   ------------------------------- */
void read_installdir(void)
{
char *c;
long fh;

DEBUG();
if (path_flg) return;

strcpy(ftppath, "dracftp.rsc");
if (shel_find(ftppath) != 0)
	{
	char *s;

	if (!strcmp(ftppath, "dracftp.rsc"))
		{
		ftppath[0] = Dgetdrv() + 'A';
		ftppath[1] = ':';
		Dgetpath(ftppath + 2, 0);
		}
	else
		{
		s = ftppath + strlen(ftppath) - 11;
		if (s == ftppath || (s[-1] != '\\' && s[-1] != '/'))
			ftppath[0] = 0;
		else
			s[-1] = 0;
		}
	}
else
	ftppath[0] = 0;
		
c = "x:\\draconis.inf";
c[0] = 'A' + bootdrv;
fh = Fopen(c, FO_READ);
if (fh > 0)
	{
	Fread((int)fh, 80, path);
	
  Fseek(6*80, (int)fh, SEEK_SET);

	if (!ftppath[0])
		if (Fread((int)fh, 80, ftppath) != 80)
			ftppath[0] = 0;
  
  Fseek(8*80, (int)fh, SEEK_SET);
	if (Fread((int)fh, 80, sharedpath) != 80)
		sharedpath[0] = 0;
	Fclose((int)fh);
	}
else
	{
	strcpy(path, "x:\\draconis");
	path[0] = c[0];
	}

if (!ftppath[0])
	{
	ftppath[0] = Dgetdrv() + 'A';
	ftppath[1] = ':';
	Dgetpath(ftppath + 2, 0);
	}

strcpy(slbpath, ftppath);
strcat(slbpath, ";");
strcat(slbpath, path);
strcat(slbpath, "\\shared;");
strcat(slbpath, sharedpath);

set_slbpath(slbpath);

strcpy(helpfile, ftppath);
strcat(helpfile, "\\help\\");
strcat(helpfile, languagecode);
strcat(helpfile, ".hlp");

path_flg = TRUE;
}
