/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

/* -------------------------------------------------
   | Replace local extension with remote extension |
   ------------------------------------------------- */
void replaceLocal(char *localfile)
{
int i, l, sl;

DEBUG();
if (!ftp_opts.do_extconv) return;

sl = (int)strlen(localfile);
for (i = 0; i < 21; i++)
	{
	l = (int)strlen(ftp_opts.local_ext[i]);
	if (localfile[sl - l - 1] == '.' && 
			!strcmp(localfile + sl - l, ftp_opts.local_ext[i]) &&
			sl > l + 1)
		{
		strcpy(localfile + sl - l, ftp_opts.remote_ext[i]);
		return;
		}
	}
}

/* -------------------------------------------------
   | Replace remote extension with local extension |
   ------------------------------------------------- */
void replaceRemote(char *remotefile)
{
int i, l, sl;

DEBUG();
if (!ftp_opts.do_extconv) return;

sl = (int)strlen(remotefile);
for (i = 0; i < 21; i++)
	{
	l = (int)strlen(ftp_opts.remote_ext[i]);
	if (remotefile[sl - l - 1] == '.' && 
			!strcmp(remotefile + sl - l, ftp_opts.remote_ext[i]) &&
			sl > l + 1)
		{
		strcpy(remotefile + sl - l, ftp_opts.local_ext[i]);
		return;
		}
	}
}

