/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-01
 * 
 */
 
 #include <stddef.h>
#include <tos.h>
#include <mt_aes.h>
#include <vdi.h>
#include <string.h>
#include <ext.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#include "..\include\dracdlg.h"
#include "..\include\slbload.h"

#include "struct.h"
#include "stsocket.h"
#include "define.h"
#include "dracftp.h"
#include "prototyp.h"

extern int 								vdi_handle;								/* VDI-Handle				*/
extern int 								work_in[11];							/* Workstationinfo	*/
extern int 								work_out[57];							/*          "				*/

extern GRECT empty;

/* Some system information */
extern int aes_version, gl_apid, naes;
extern int planes, dither_index, dither_colours, colours, pixel_type, truecolor_type;
extern int smallfont;
extern char tr_cols[256], tr_base[256];
extern int default_fsize, tx_width, tx_height;

extern char ftppath[256], helpfile[256];

/* Main window managment */
extern int main_x, main_y;
extern int exit_flg;
extern OBJECT *maindial, *menu_adr, *iconified, *v_iconified;
extern int connect_tabs[3], option_tabs[6];
extern char *symbols, *buttons;
extern char *grf_buttons;
extern int grfbut_size;
extern PALETTE_FILE but_palheader;
extern int ftp_button_no;

/* Dialog manager */
extern OBJECT *connect_dial, *option_dial;

/* Message handler */
extern EVNTDATA evnt;
extern int msg[8];
extern int clicks, k_return, which;

extern int ftp_socket;
extern char name_buffer[30];

/* Messages */
extern OBJECT *cpyinfo;
extern char *error_write;
extern char *recvstring, *sendstring, *byt_info, *bps_info;
extern char *aborted, *done, *readdir, *connecting, *userauth;
extern char *connected, *closeconnection;
extern char *byte_info, *std_file, *dir_type, *link_type;
extern char *offline_msg, *nodriver_msg;
extern char *unknown_host, *unknown_service, *connect_unable, *login_error;
extern char *get_error, *mem_error, *restart_error, *create_error;
extern char *no_logfile, *cantopen_log, *tomany_windows, *open_error;
extern char *alloc_error, *read_error, *scrap_error, *unknown;
extern char *languagecode, *chdir_label, *site_label, *quote_label;
extern char *logfilelabel, *notpalet;

extern unsigned long transmission_start;
#ifdef EVAL
	extern OBJECT *notdemo;
#endif

/* Local information */
extern char local_dir[256];
extern int local_filecnt, local_filetop;
extern int local_left;
extern struct ftp_lsblk *localfiles;

/* Ftp Storage */
extern char ftp_remote[256], ftp_local[256];
extern int ftp_filecnt, ftp_filetop;
extern int ftp_left;
extern struct ftp_lsblk *ftpfiles;

/* FTP connections */
extern CONN_INF *conn_defs;
extern int conn_cnt;
extern CONN_INF act_conndef;
extern CONN_INF conndefault;
#ifdef EVAL
  extern int transferred;
#endif

/* FTP options */
#define DIR_SIZE 1
#define DIR_DATE 2
#define DIR_USER 4
#define DIR_GROUP 8
#define DIR_ATTR	16
extern ALL_OPTS ftp_opts;

#ifdef TRAP_LOG
#		define	DEBUG()		logfunc(__FILE__,__LINE__) 
#else
#ifdef DEBUG_LOG
#		define 	DEBUG()		printf("%s:%d: %s\n ", __FILE__,__LINE__,__FUNCTION__);
#else
#		define	DEBUG()
#endif
#endif
