/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

/* -------------------
   | Set file marker |
   ------------------- */
void mark_file(int obj)
{
int top, cnt, pos, i;
int ox, oy, simple_mark = FALSE;
struct ftp_lsblk *lsblk;

DEBUG();
if ((obj & 0x7FFF) == RDIR)
	{
	lsblk = ftpfiles;
	top = ftp_filetop;
	cnt = ftp_filecnt;
	}
else
	{
	lsblk = localfiles;
	top = local_filetop;
	cnt = local_filecnt;
	}

objc_offset(maindial, obj & ~0x8000, &ox, &oy);
pos = ((evnt.y - oy) / tx_height) + top;
if (pos < cnt)
	{
	if ((obj & 0x8000) && !(evnt.kstate & 3) && (lsblk[pos].dir || lsblk[pos].link))
		{
		if ((obj & 0x7FFF) == RDIR)
			{
			if (ftp_socket)
				{
				if (ftp_setcwd(ftp_socket, lsblk[pos].name))
					{
					ftp_getcwd(ftp_socket, ftp_remote);
					ReadDirectory();
				
					SetInfo(done);
					}
				else
					simple_mark = TRUE;
				}
			}
		else
			{
			if (!strcmp(lsblk[pos].name, ".."))
				{
				char *s;
				
				s = strrchr(local_dir + 3, '\\');
				if (s) 
					*s = 0;
				else
					local_dir[3] = 0;
				GetLocaldir();
				}
			else
				{
				if (strchr(local_dir, 0)[-1] != '\\')
					strcat(local_dir, "\\");
				strcat(local_dir, lsblk[pos].name);
				GetLocaldir();
				}
			redraw_object(maindial, LDIR);
			}
		}
	else
		simple_mark = TRUE;
		
	if (simple_mark)
		{
		int pos2, w, h;
		
		if (!(evnt.kstate & 3))
			{
			for (i = 0; i < cnt; i++)
				lsblk[i].sel = 0;
			}
			
		lsblk[pos].sel ^= 1;
		redraw_object(maindial, obj);

		if ((evnt.bstate & 1) && clicks == 1)
			{		
			graf_rubbox(evnt.x, evnt.y, 50, 2, &w, &h);
			pos2 = ((evnt.y - oy + h) / tx_height) + top;
		
			if (pos2 >= cnt) pos2 = cnt - 1;
			for (i = pos + 1; i < pos2; i++)
				lsblk[i].sel ^= 1;
			redraw_object(maindial, obj);
			}
		}
		
	delay(200);
	}
}

