/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-01
 * 
 */
 
 int appl_id;					/* Applikation Identifier */

int 								vdi_handle;								/* VDI-Handle				*/
int 								work_in[11];							/* Workstationinfo	*/
int 								work_out[57];							/*          "				*/

GRECT empty = {0,0,0,0};

/* Some system information */
int aes_version, naes;
#ifndef __AHCC__
int gl_apid;
#else
extern int gl_apid;
#endif
int planes, dither_index, dither_colours, colours, pixel_type, truecolor_type = 1;
int smallfont = 0;
char tr_cols[256], tr_base[256];
int default_fsize, tx_width, tx_height;

char ftppath[256], helpfile[256];

/* Main window managment */
int main_x = -1, main_y;
int exit_flg;
OBJECT *maindial, *menu_adr, *iconified, *v_iconified;
char *symbols, *buttons;
PALETTE_FILE but_palheader;
int ftp_button_no = -1;

char *grf_buttons;
int grfbut_size;

/* Dialog manager */
OBJECT *connect_dial, *option_dial;
int connect_tabs[3], option_tabs[6];

/* Message handler */
EVNTDATA evnt;
int msg[8];
int clicks, k_return, which;

int ftp_socket = 0;
char name_buffer[30];

/* Messages */
OBJECT *cpyinfo;
char *error_write;
char *recvstring, *sendstring, *byt_info, *bps_info;
char *aborted, *done, *readdir, *connecting, *userauth;
char *connected, *closeconnection;
char *byte_info, *std_file, *dir_type, *link_type;
char *offline_msg, *nodriver_msg;
char *unknown_host, *unknown_service, *connect_unable, *login_error;
char *get_error, *mem_error, *restart_error, *create_error;
char *no_logfile, *cantopen_log, *tomany_windows, *open_error;
char *alloc_error, *read_error, *scrap_error, *unknown;
char *languagecode, *chdir_label, *site_label, *quote_label;
char *logfilelabel, *notpalet;

unsigned long transmission_start;
#ifdef EVAL
	OBJECT *notdemo;
#endif

/* Local information */
char local_dir[256];
int local_filecnt = 0, local_filetop = 0;
int local_left = 0;
struct ftp_lsblk *localfiles;

/* Ftp storage */
char ftp_remote[256];
int ftp_filecnt = 0, ftp_filetop = 0;
int ftp_left = 0;
struct ftp_lsblk *ftpfiles;

/* FTP connections */
CONN_INF *conn_defs;
int conn_cnt = 0;
CONN_INF act_conndef = {0, 0, 5, 30, 21, 0, 0, 0, "\0", "\0",
											  "\0", "\0", "\0", "\0"};
CONN_INF conndefault = {0, 0, 5, 30, 21, 0, 0, 0, "\0", "\0",
											  "\0", "\0", "\0", "\0"};
#ifdef EVAL
  int transferred = 0;
#endif

/* FTP options */

ALL_OPTS ftp_opts = {0, 1, 1, 1, 1, 1, 1, 0,
										 4096, 4096, 0, 0, 8,
										 1, 0, 1, 0, 1,
										 "\0", 
										 {"jpeg", "tar.gz", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0", "\0"},
										 {"jpg", "tgz", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0", "\0"},
										 "dracftp.log",
										 {"htm", "html", "txt", "asc", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0", "\0", "\0", "\0",
										  "\0", "\0"},
										  0, 0,						/* w, h */
										  TRUE,
										  4, 3, 2, 1,			/* Same, newer, older, non-exist */
										  TRUE, TRUE,			/* recursive, only_newer */
										  TRUE, TRUE,			/* ext_options, confirm_overwr */
										  TRUE, TRUE,			/* ftp_recursive, ftp_only_newer */
										  TRUE,						/* ftp_confirm_overwr	*/
#ifndef __AHCC__
										  TRUE, TRUE,			/* icon_cache, bubbles */
#else
											FALSE, TRUE,
#endif
										  "buttons",

											DIR_SIZE|DIR_DATE,
											DIR_SIZE|DIR_DATE,
											{12, 8, 16, 10, 8, 8},
											{12, 8, 16, 10, 8, 8},
											"\0", "\0",
											};
