#include <tos.h>
#include <aes.h>
#include <vdi.h>
#include <stdio.h>

int 								vdi_handle;							  /* VDI-Handle       */
int									gl_apid;
int 								work_in[11];							/* Workstationinfo	*/
int 								work_out[57];							/*          "				*/

char palette[16 * 3 + 256 * 3];
int colours;

/* ---------------------------- */
/* | Arbeitsstation schlieen | */
/* ---------------------------- */
void cls_vwork(void)
{
v_clsvwk(vdi_handle);
}

/* ---------------------------- */
/* | Virtuelle Arbeitsstation | */
/* ---------------------------- */
void open_vwork(void)
{
register int i;
int dummy;

vdi_handle = graf_handle(&dummy, &dummy, &dummy, &dummy);

for(i = 0; i < 10; work_in[i++] = 1);
work_in[10] = 2;

v_opnvwk(work_in, &vdi_handle, work_out);

colours = work_out[13];
}

void dump(int out)
{
static char hex[] = "0123456789ABCDEF";

Cconout(hex[(out >> 4) & 0xF]);
Cconout(hex[out & 0xF]);
}

/* -------------------------
   | Main routine of STTCP |
   ------------------------- */
void main(void)
{
long fh;
int offset, i, rgb[3];

gl_apid = appl_init();
open_vwork();

fh = Fopen("SYSTEM.CLC", FO_READ);
if (fh > -1)
	{
	Fread((int)fh, sizeof(palette), palette);
	Fclose((int)fh);
	}

if (colours == 256)
	offset = 16 * 3;
else
	offset = 0;

printf("Offset: %d\n", offset);
for (i = 0; i < colours; i++)
	{
	vq_color(vdi_handle, i, 0, rgb);
	
	printf("\033Y%c%c#", ' ' + (i % 22) + 1, ' ' + (i / 22) * 8);
	fflush(stdout);
		
	palette[offset++] = (int)(rgb[0] * 255L / 1000);
	palette[offset++] = (int)(rgb[1] * 255L / 1000);
	palette[offset++] = (int)(rgb[2] * 255L / 1000);
	
	dump(palette[offset - 3]);
	dump(palette[offset - 2]);
	dump(palette[offset - 1]);
	}

if (i > 22) i = 23;

printf("\033Y%c%c", ' ' + i, ' ');
printf("3 * %d = %d Bytes\n", colours, colours * 3);
	
fh = Fcreate("SYSTEM.CLC", 0);
if (fh > -1)
	{
	Fwrite((int)fh, sizeof(palette), palette);
	Fclose((int)fh);
	}
printf("Okay\n");

cls_vwork();
appl_exit();
}

