/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

/* -------------------------
   | Show file information |
   ------------------------- */
void ShowFileInfo(struct ftp_lsblk *files, int cnt)
{
static int info_ids[]= {NAME1, NAME2, DATEINFO, FILESIZE,
												TYPEINFO, INFOOK, MORECNC, NEXTINFO,
												0};
int i, dirnum, filenum, obj;
long totalsize;
OBJECT *tree;
struct tm tblock;

DEBUG();
totalsize = 0;
dirnum = filenum = 0;

for (i = 0; i < cnt; i++)
	if (files[i].sel)
		{
		if (files[i].dir) 
			dirnum++;
		else 
			{
			filenum++;
			totalsize += files[i].size;
			}
		}
if (!(dirnum + filenum)) return;

if (dirnum + filenum > 1)
	{
	static int more_help[] = {FILENUM, TOTALBYT, DIRNUM,
													  CANCMORE, MOREDET, 0};
	
	rsrc_gaddr(R_TREE, MOREINFO, &tree);
	sprintf(tree[FILENUM].ob_spec.free_string, "%6d", filenum);
	sprintf(tree[DIRNUM].ob_spec.free_string, "%6d", dirnum);
	sprintf(tree[TOTALBYT].ob_spec.free_string, "%10ld", totalsize);
	
	open_kinddialog(tree, tree[MOREINFO_TITLE].ob_spec.free_string, iconified, SMALLER|NAME|MOVER|CLOSER);
	dlgset_help_info(tree, helpfile, more_help, "MORE_");
	obj = do_dialog(tree, 0, app_callback);
	close_dialog(tree, TRUE);
	
	if (obj != MOREDET) return;
	}

rsrc_gaddr(R_TREE, FINFO, &tree);
if (dirnum + filenum > 1)
	{
	tree[MORECNC].ob_flags &= ~HIDETREE;
	EnableObj(tree, MORECNC);
	tree[NEXTINFO].ob_flags &= ~HIDETREE;
	EnableObj(tree, NEXTINFO);
	tree[INFOOK].ob_flags |= HIDETREE;
	DisableObj(tree, INFOOK);
	}
else
	{
	tree[MORECNC].ob_flags |= HIDETREE;
	DisableObj(tree, MORECNC);
	tree[NEXTINFO].ob_flags |= HIDETREE;
	DisableObj(tree, NEXTINFO);
	tree[INFOOK].ob_flags &= ~HIDETREE;
	EnableObj(tree, INFOOK);
	}
	
for (i = 0; i < cnt; i++)
	if (files[i].sel)
		{
		tblock.tm_sec 	= files[i].sec;
		tblock.tm_min 	= files[i].min;
		tblock.tm_hour 	= files[i].hour;
		tblock.tm_mday 	= files[i].day;
		tblock.tm_mon 	= files[i].month - 1;
		tblock.tm_year 	= files[i].year - 1900;
		tblock.tm_yday = 0;
		tblock.tm_wday = 0;
		tblock.tm_isdst = 0;
		
		strcpy(tree[DATEINFO].ob_spec.free_string, asctime(&tblock));
		*strchr(tree[DATEINFO].ob_spec.free_string, '\n') = 0;
		
		sprintf(tree[FILESIZE].ob_spec.free_string, "%8ld", files[i].size);
		strncpy(tree[NAME1].ob_spec.free_string, files[i].name, 32);
		tree[NAME1].ob_spec.free_string[32] = 0;
		
		if (tree[NAME1].ob_spec.free_string[31])
			{
			strncpy(tree[NAME2].ob_spec.free_string, files[i].name + 32, 32);
			tree[NAME2].ob_spec.free_string[32] = 0;
			}
		else
			tree[NAME2].ob_spec.free_string[0] = 0;

		if (files[i].dir)
			tree[TYPEINFO].ob_spec.free_string = dir_type;
		else
			if (files[i].link)
				tree[TYPEINFO].ob_spec.free_string = link_type;
			else
				tree[TYPEINFO].ob_spec.free_string = std_file;

		open_kinddialog(tree, tree[FINFO_TITLE].ob_spec.free_string, iconified, SMALLER|NAME|MOVER|CLOSER);
		dlgset_help_info(tree, helpfile, info_ids, "INFO_");
		obj = do_dialog(tree, 0, app_callback);
		close_dialog(tree, TRUE);
		if (obj != NEXTINFO) break;
		}
}
