/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

/* -----------------------
   | Get new folder name |
   ----------------------- */
int InputSomething(char *label, char *entry, char *help)
{
static int help_ids[] = {INPUTFIELD, INPUT_OKAY, INPUT_CANCEL, 0};
OBJECT *ctree;
int obj;

DEBUG();
rsrc_gaddr(R_TREE, INPUT, &ctree);

ctree[INPUTLABEL].ob_spec.free_string = label;
strncpy(ctree[INPUTFIELD].ob_spec.tedinfo->te_ptext, entry, 35);

open_kinddialog(ctree, NULL, iconified, SMALLER|NAME|MOVER|CLOSER);
if (help != NULL)
	dlgset_help_info(ctree, helpfile, help_ids, help);
obj = do_dialog(ctree, INPUTFIELD, app_callback);
close_dialog(ctree, TRUE);

strcpy(entry, ctree[INPUTFIELD].ob_spec.tedinfo->te_ptext);
return (obj == INPUT_OKAY);
}