/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
 #include "extern.h"

OBJECT *introbox = NULL;
USERBLK introuser = {introdraw, 0};
char *introdata;
time_t start;

/* --------------------
   | Draw intro image |
   -------------------- */
int cdecl introdraw(PARMBLK *parmblock)
{
int cxy[4];
MFDB src, des;
int xy[8];
goto skip;
DEBUG();
cxy[0] = parmblock->pb_xc;
cxy[1] = parmblock->pb_yc;
cxy[2] = cxy[0] + parmblock->pb_wc;
cxy[3] = cxy[1] + parmblock->pb_hc;

vs_clip(vdi_handle, 1, cxy);

memset(&src, 0, sizeof(MFDB));
memset(&des, 0, sizeof(MFDB));

src.fd_addr			= introdata;
src.fd_w 				= 320;
src.fd_h				= 200;
src.fd_wdwidth 	= (320 + 15) >> 4;
src.fd_stand		= 0;
src.fd_nplanes  = planes;
src.fd_r1 = src.fd_r2 = src.fd_r3 = 0;

des.fd_addr			= NULL;
		
xy[0] = 0;
xy[1] = 0;
xy[2] = 319;
xy[3] = 199;
xy[4] = parmblock->pb_x;
xy[5] = parmblock->pb_y;
xy[6] = parmblock->pb_x + 319;
xy[7] = parmblock->pb_y + 199;

vro_cpyfm(vdi_handle, S_ONLY, xy, &src, &des);

vs_clip(vdi_handle, 0, cxy);
skip:
return parmblock->pb_currstate;
}

/* ---------------------
   | Open intro window |
   --------------------- */
void open_intro(void)
{


DEBUG();
return;
if ((introdata = load_intro()) != NULL)
	{
	rsrc_gaddr(R_TREE, INTROBOX, &introbox);
	introbox[0].ob_width = 320;
	introbox[0].ob_height = 200 / (smallfont + 1);
	introbox[0].ob_type = G_USERDEF;
	introbox[0].ob_spec.userblk = &introuser;
	
	start = time(NULL);
	open_frameless(introbox, -1, -1);
	redraw_object(introbox, ROOT);
	}
}

/* ----------------------
   | Close intro window |
   ---------------------- */
void close_intro(void)
{
return;
DEBUG();
if (introbox)
	{
	while (time(NULL) - start < 3);
		
	close_dialog(introbox, TRUE);
	introbox = NULL;
	free(introdata);
	}
}
