/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

int main_width, main_height;

/* Distances */
int info_diff;
int tpanel_bottom;
int connect_right, disconnect_right, connect_bottom;
int action_bottom;

void init_mainsizer(void)
{
DEBUG();
main_width = maindial->ob_width;
main_height = maindial->ob_height;

tpanel_bottom 		= main_height - maindial[TYPEPANEL].ob_y;
connect_right 		= main_width - maindial[FCONNECT].ob_x;
connect_bottom 		= main_height - maindial[FCONNECT].ob_y;
disconnect_right 	= main_width - maindial[FDISCONN].ob_x;
info_diff		 			= main_width - maindial[INFOB].ob_width;
action_bottom 		= main_height - maindial[LACTIONS].ob_y;
}

void resize_main(int newwidth, int newheight)
{
int area_diffw, area_diffh;
int zw;

DEBUG();
newwidth &= ~1;
area_diffw = (newwidth - main_width) / 2;
area_diffh = newheight - main_height;

maindial->ob_width 			= newwidth;
maindial->ob_height 		= newheight;

maindial[RACTIONS].ob_y = 
maindial[LACTIONS].ob_y = newheight - action_bottom;

maindial[TYPEPANEL].ob_y = newheight - tpanel_bottom;

maindial[FCONNECT].ob_x = newwidth - connect_right;
maindial[FCONNECT].ob_y = newheight - connect_bottom;
maindial[FDISCONN].ob_x = newwidth - disconnect_right;
maindial[FDISCONN].ob_y = 
maindial[FCONNECT].ob_y = newheight - connect_bottom;

maindial[INFOB].ob_width = newwidth - info_diff;
maindial[INFOB].ob_y = newheight - maindial[INFOB].ob_height;

maindial[MAINSIZER].ob_x = newwidth - maindial[MAINSIZER].ob_width;
maindial[MAINSIZER].ob_y = newheight - maindial[MAINSIZER].ob_height;

maindial[LAREA].ob_width += area_diffw;
maindial[RAREA].ob_width += area_diffw;

maindial[RACTIONS].ob_x   = 
maindial[RAREA].ob_x 		 += area_diffw;

maindial[LAREA].ob_height += area_diffh;
maindial[RAREA].ob_height += area_diffh;

maindial[LDIR].ob_width   += area_diffw;
maindial[RDIR].ob_width   += area_diffw;
maindial[LDIR].ob_height	+= area_diffh;
maindial[RDIR].ob_height	+= area_diffh;

maindial[LDIRINFO].ob_width += area_diffw;
maindial[RDIRINFO].ob_width += area_diffw;

maindial[SEND].ob_y 			+= area_diffh;
maindial[RECEIVE].ob_y 		+= area_diffh;

maindial[SEND].ob_x				+= area_diffw;
maindial[RECEIVE].ob_x		+= area_diffw;

maindial[LSLDBKG].ob_height += area_diffh;
maindial[RSLDBKG].ob_height += area_diffh;
maindial[LSLDBKG].ob_x			+= area_diffw;
maindial[RSLDBKG].ob_x			+= area_diffw;

maindial[LSLDBOT].ob_y    	+= area_diffh;
maindial[LSLDBOT].ob_width 	+= area_diffw;
maindial[RSLDBOT].ob_y    	+= area_diffh;
maindial[RSLDBOT].ob_width 	+= area_diffw;

align_slider_objects(maindial, LSLDBKG, LUP, LSLD, LSLDB, LDOWN);
align_slider_objects(maindial, LSLDBOT, LLEFT, LSLDH, LSLDBH, LRIGHT);
align_slider_objects(maindial, RSLDBKG, RUP, RSLD, RSLDB, RDOWN);
align_slider_objects(maindial, RSLDBOT, RLEFT, RSLDH, RSLDBH, RRIGHT);

zw = calc_hwidth(ftp_opts.local_bits, ftp_opts.local_sizes) - maindial[LDIR].ob_width / tx_width;
if (zw < 0) zw = 0;
if (local_left > zw)
	local_left = zw;

zw = local_filecnt - maindial[LDIR].ob_height / tx_height;
if (zw < 0) zw = 0;
if (local_filetop > zw)
	local_filetop = zw;

zw = calc_hwidth(ftp_opts.ftp_bits, ftp_opts.ftp_sizes) - maindial[RDIR].ob_width / tx_width;
if (zw < 0) zw = 0;
if (ftp_left > zw)
	ftp_left = zw;

zw = ftp_filecnt - maindial[RDIR].ob_height / tx_height;
if (zw < 0) zw = 0;
if (local_filetop > zw)
	local_filetop = zw;
	
open_kinddialog(maindial, maindial[MAIN_TITLE].ob_spec.free_string, iconified, SMALLER|NAME|MOVER|CLOSER|FULLER);

set_dirslider(FALSE, TRUE);
set_dirslider(TRUE, TRUE);
set_dirhslider(FALSE, TRUE);
set_dirhslider(TRUE, TRUE);

main_width = newwidth;
main_height = newheight;
}
