/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-01
 * 
 */
 
 																				/* ASSERT.C
																				   -------- */
void logfunc(char *file, long line);

																				/* ABOUT.C
																				   ------- */
void about_info(void);

																				/* APP.C
																				   ----- */
void AppConnect(int *msg);
void AppConnectS(int *msg);
void AppCd(int *msg);
void AppGet(int *msg);
void AppPut(int *msg);
void AppType(int *msg);
void AppClose(int *msg);

																				/* BLTCOPY.C
																				   --------- */
void blt_copy(void *from, int xf, int yf, void *to, int xt, int yt, int w, int h, int cpy_mode);

																				/* COLORING.C
																				   ---------- */
int colorFiles(int filecnt, struct ftp_lsblk *files,
							 int comparecnt, struct ftp_lsblk *cfiles);
								
																				/* CONFIG.C
																				   -------- */
void get_bootdrive(void);
void read_installdir(void);

																			/* File: CONNECT.C
																			   --------------- */
int drop_connect(void);
void connect_to(void);
void connect_now(void);
void disconnect(void);

																			/* File: CPYINFO.C
																			   --------------- */
int is_cpyinfoOpen(void);
void open_cpyinfo(int op, char *fname);
void set_cpyinfo(long currsize, long totalsize);
void close_cpyinfo(void);

																			/* File: DIALOG.C
																			   -------------- */
void BindTab(OBJECT *tree1, int obj1, int new_obj);
int CombineDialogs(OBJECT **newtree, OBJECT *tree1, OBJECT *tree2);

																				/* File: DIR.C
																				   ----------- */
void sort_dir(int filecnt, struct ftp_lsblk *files, int sort);
int cdecl dir_view(PARMBLK *paramblock);
void set_dirslider(int left, int redraw);
int calc_hwidth(int bits, int *sizes);
void set_dirhslider(int left, int redraw);
int select_sort(int sort);

																				/* File: EXTCONV.C
																				   --------------- */
void replaceLocal(char *localfile);
void replaceRemote(char *localfile);

																				/* File: FILEMARK.C
																				   ---------------- */
void mark_file(int obj);

																			/* File: FREEDROP.C
																			   ---------------- */
int free_droplist(int x, int y, int w, char **strings);
																				   
																				/* File: FTPFUNC.C
																				   --------------- */
int colorRemoteFiles(void);
void ReadDirectory(void);
void RenameRemote(void);
void RemoveRemote(int type);
void remote_popup(void);

																				/* File: FTPLIB.C
																				   -------------- */
int ftp_connect(char *server, int port);
int ftp_login(int s, char *user, char *pass);
int ftp_close(int s);
int ftp_abort(int s);
int ftp_getcwd(int s, char *buf);
int ftp_setcwd(int s, char *buf);
int ftp_mkdir(int s, char *buf);
int ftp_unlink(int s, char *buf);
int ftp_rmdir(int s, char *buf);
int ftp_rename(int s, char *old, char *new);
int ftp_binary(int s, int flg);
int ftp_ls(int s, int *cnt, struct ftp_lsblk **fblk);
int ftp_restart(int s, long pos);
int ftp_quote(int s, char *quote);
int ftp_site(int s, char *site);
int ftp_retrieve(int s, char *remotefile, long offset);
int ftp_getblock(int s, int bufsize, void *buffer);
int ftp_store(int s, char *remotefile, long offset);
int ftp_putblock(int s, int bufsize, void *buffer);
int ftp_return(int s, char *buf, SOCK_BUF *sbuf);

																				/* GRAFBUTT.C
																			   	 ---------- */
void init_grfbuttons(void);
void position_grfbuttons(void);
int cdecl graf_butt(PARMBLK *paramblock);
void set_buttonstate(void);

																				/* GRAFMODE.C
																			   	 ---------- */
void detect_pixeltype(void);

																				/* IMAGES.C
																				   -------- */
void init_colorcache(void);
char *load_intro(void);
void load_my_images(void);
void load_ftpcollections(void);
void load_collections(char *file);
void load_ftpbuttons(void);
void select_ftpbuttons(int x, int y, int w);
char *getCollectionName(void);

																				/* INFO.C
																				   ------ */
void ShowFileInfo(struct ftp_lsblk *infofiles, int cnt);

																			/* File: INPUT.C
																				 ------------- */
int InputSomething(char *label, char *entry, char *help);

																			/* File: INTRO.C
																			   ------------- */
int cdecl introdraw(PARMBLK *parmblock);
void open_intro(void);
void close_intro(void);

																				/* LOCALIO.C
																				   --------- */
int local_dirsel(void);
int colorLocalFiles(void);
void GetLocaldir(void);
int	MakeLocalDir(void);
void RenameLocals(void);
void RemoveLocals(int type);
void local_popup(void);

																				/* LOG.C
																				   ----- */
void open_log(void);
void close_log(void);
void log_dump(unsigned char *buffer, int size);
void logging(char *buffer, int len);
long log_send(int sfd, void *buf, long len, unsigned flags);

																				/* MAIN.C
																				   ------ */
void cdecl app_callback( int awhich, int *amsg, EVNTDATA *ev, int kr, int br );
void message_handler(void);
void menu_action(int *msg);
int menu_keys(void);
void set_menu(void);

																				/* MAINSIZE.C
																				   ---------- */
void init_mainsizer(void);
void resize_main(int newwidth, int newheight);

																				/* MISC.C
																				   ------ */
long check_cookie(long cook);
int CheckSystem(void);
int rc_intersect(GRECT *s1, GRECT *s2);
void SetInfo(char *newinfo);
int GetNewFolderName(void);
int GetRenamedName(char *oldname);
int check_connection(int function);
void wait_mouse_release(void);
void not_demo(void);
void check_mouse(void);
void check_events(void);

																				/* OPTIONS.C
																				   --------- */
void set_options(void);
void save_options(void);
void load_options(void);
void copy_options(int direction);
void copy_connection(int direction);
void save_connection(void);
void delete_connection(void);
void get_connection(char *cname);

																				/* POPUP.C
																				   ------- */
int positioned_popup(OBJECT *poptree, int x, int y);
int popup(OBJECT *poptree);

																				/* RECEIVE.C
																				   --------- */
void receive_files(int callflg);
int receive_file(struct ftp_lsblk *remotefile, char *local);

																				/* RSC.C
																				   ----- */
int init_rsc(void);

																				/* SEND.C
																				   ------ */
void send_files(int flg);
int send_file(char *localfile, long totalsize);

																				/* TRNSMODE.C
																				   ---------- */
int CheckTransfermode(char *file);

																				/* VIEW.C
																				   ------ */
void view_locals(void);
void view_remotes(void);
void view_file(char *file, int binmode, char *title);
int is_view(int w_handle);
void view_msg(int *msg);
void view_click(void);
void set_view_menu(void);
void set_ascii_mode(void);
void set_binary_mode(void);
void view_copy(void);

																				/* File: USERDEF.C
																				   --------------- */
void obj_clip(PARMBLK *parm, int flg);
void icon_copy(void *from, int xf, int yf, int xt, int yt, int w, int h);
