/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tos.h>
#include <aes.h>
#include <setjmp.h>

void cls_vwork(void);

jmp_buf trapcont;

long regs[18];
char buffer[81 * 25];

char *regnames[] = {"D0", "D1", "D2", "D3", "D4", "D5", "D6", "D7",
			 						  "A0", "A1", "A2", "A3", "A4", "A5", "A6", "A7",
			 						  "USP"};

void dump_locations(char *buffer);

/* -------------------------
   | Dump trap information |
   ------------------------- */									 
void trapinfo(int type)
{
/*int i, j;
unsigned char *stack;*/
char key;

sprintf(buffer, "\nException-Type: %d at address $%08lx\n", type, regs[17]);
/*strcat(buffer, "------------------\n");

for (i = 0; i < 17; i++)
	{
	sprintf(buffer + strlen(buffer), "%s=$%08lx", regnames[i], regs[i]);
	if (i < 16)
		strcat(buffer, ", ");

	if ((i + 1) % 4 == 0)
		strcat(buffer, "\n");
	}
strcat(buffer, "\n\n");

strcat(buffer, "Stack dump:\n");
strcat(buffer, "-----------\n");

stack = (unsigned char *)regs[16];
for (i = 0; i < 4; i++)
	{
	sprintf(buffer + strlen(buffer), "%08lx: ", stack);
	for (j = 0; j < 16; j++)
		sprintf(buffer + strlen(buffer), "%02x ", (int)*(stack++));
	strcat(buffer, "\n");
	}
*/
sprintf(buffer + strlen(buffer), "\nBasepage: $%08lx\n", _BasPag);
sprintf(buffer + strlen(buffer), "Text segment: $%08lx		length: $%lx\n", _BasPag->p_tbase, _BasPag->p_tlen);
/*sprintf(buffer + strlen(buffer), "Data segment: $%08lx		length: $%lx\n", _BasPag->p_dbase, _BasPag->p_dlen);
sprintf(buffer + strlen(buffer), "BSS segment : $%08lx		length: $%lx\n", _BasPag->p_bbase, _BasPag->p_blen);*/

strcat(buffer, "\nLast logged locations:\n");
dump_locations(buffer);

printf(buffer);

/*printf("\nPlease report at least the 'Basepage', 'Exception type & address',\n");
printf("and the first line of the stack dump to 'draconis@atari.org'\n");*/
printf("\nPlease report the above information to 'draconis@atari.org'\n");

printf("Also it would be helpful, if you can describe detailed the situation\nwhen and how this error happens\n");

printf("\n(D)ump, (C)ontinue, E(x)it...\n");
for(;;)
	{
	key = Crawcin();

	switch (key & 0xDF)
		{
		case 'D':
			{
			FILE *fh = fopen("DRACFTP.DMP", "a+");
			
			if (fh)
				{
				fprintf(fh, ">-------------------------------<\n");
				fprintf(fh, buffer);
				fclose(fh);
				}
			break;
			}
		
		case 'C':
			longjmp(trapcont, 0);
			break;
	
		case 'X':
			cls_vwork();
			appl_exit();
			exit(0);
		}
	}
}
